import os
import argparse as ap
import random
import math
 
Path = "/home/vipl/luozhengdong/WIKI_FOOD_DATASET_OK/ISIA Food_500/"
Out_Path = "./"
class_file = './ISIAFood500_classLabel.txt'
 
if __name__ == "__main__":
    # Argument Parser
    parser = ap.ArgumentParser()
    parser.add_argument("--images", help="Path to images",
                        default=Path)
    parser.add_argument("--output", help="Path to output directory",
                        default=Out_Path)
    args = vars(parser.parse_args())
 
    source_path = args["images"]
    output_dir = args["output"]
    val_rate = 0.1
    test_rate = 0.3
    train_rate = 0.6

 
    # if not os.path.exists(output_dir):
    #     os.makedirs(output_dir)
    file_data = open(class_file)
    lines = file_data.readlines()
    # class_finetune_file = open('class_finetune.txt', 'w')
    for line in lines:
        class_name = line.split('\t')[0]

        category = line.split('\t')[1]
        # finetune = class_name
        # class_finetune_file.write()
        print(class_name)
        images_path = os.path.join(source_path, class_name)
        images_names = os.listdir(images_path)
        # print images_names

        images_list = []
        for img in images_names:
            images_list.append(img)
            # print images_list
        random.shuffle(images_list)
        annotation_num = len(images_list)
        val_num = int(math.ceil(val_rate * annotation_num))
        test_num = int(math.ceil(test_rate * annotation_num))
        val = images_list[0:val_num]
        test = images_list[val_num:val_num+test_num]
        train = images_list[val_num+test_num:]
        print(len(train))


        train = sorted(train)
        val = sorted(val)
        test = sorted(test)
        train_fout = open('train_finetune.txt', 'a+')
        train_feature = open('train_feature.txt', 'a+')
        for train_ele in train:
            # print ele
            output = class_name+'/'+train_ele+' '+category.strip()
            feature = class_name+'/'+train_ele
            print(output)
            train_fout.write(output + "\n")
            train_feature.write(feature + "\n")
        # fout.close()
        val_fout = open('val_finetune.txt', 'a+')

        for val_ele in val:
            output = class_name+'/'+val_ele+' '+category.strip()
            val_fout.write(output + "\n")
        # fout.close()
        test_fout = open('test_finetune.txt', 'a+')
        test_feature = open('test_feature.txt', 'a+')
        for test_ele in test:
            output = class_name + '/' + test_ele + ' ' + category.strip()
            test_fout.write(output + "\n")
            feature = class_name+'/'+test_ele
            test_feature.write(feature + "\n")
    train_fout.close()
    val_fout.close()
    test_fout.close()
    train_feature.close()
    train_feature.close()

